import os
from os import sep
#import create_boundary
import project
try:
    from pylab import plot,show,xlabel,ylabel,legend,title,savefig,hold
except:
    print 'Cannot import pylab plotting will not work. Csv files are still created'
from anuga.utilities.polygon import inside_polygon
from anuga.utilities.numerical_tools import ensure_numeric
from Scientific.IO.NetCDF import NetCDFFile


def get_sts_gauge_data(filename,polygon,verbose=False):
    from Numeric import asarray,transpose,sqrt,argmax,argmin,arange,Float,\
        compress,zeros,fabs,take
    fid = NetCDFFile(filename+'.sts', 'r')    #Open existing file for read
    x = fid.variables['x'][:]+fid.xllcorner   #x-coordinates of vertices
    y = fid.variables['y'][:]+fid.yllcorner   #y-coordinates of vertices
    print 'heloo', len(x), len(y)
    points=transpose(asarray([x.tolist(),y.tolist()]))
    time=fid.variables['time'][:]
    elevation=fid.variables['elevation'][:]
    indices=inside_polygon(points, polygon, closed=True, verbose=False)
    inside_points=take(points,indices,0)
    elevation=take(elevation,indices,0)
    if verbose:
        inside_points_array=ensure_numeric(inside_points)#for plotting only
        #plot(points[:,0],points[:,1],'o')
        #plot(inside_points_array[:,0][::5],inside_points_array[:,1][::5],'o')
        polygon=ensure_numeric(polygon)
        #plot(polygon[:,0],polygon[:,1])
        #show()
        
    quantity_names=['stage','xmomentum','ymomentum']
    
    fid_sts = open(project.boundaries_dir+sep+'sts_gauge.csv', 'w')
    s = 'time, stage, xmomentum, ymomentum \n'
    fid_sts.write(s)
    quantities = {}
    for i, name in enumerate(quantity_names):
        quantities[name] = fid.variables[name][:]
        print len(quantities[name])
        if inside_points is not None:
            quantities[name] = take(quantities[name],indices,1)
            for j in range(len(x)): 
                stage = quantities[name][:,j]
                xmomentum = quantities[name][:,j]
                ymomentum = quantities[name][:,j]
                #print 'hello', len(stage)
                #s = '%.2f, %.2f, %.2f, %.2f\n' %(time[j], stage, xmomentum, ymomentum)
                #fid_sts.write(s)
        else:
            msg = 'No gauges found inside polygon'
            raise msg
    fid.close()

    return inside_points,quantities,elevation,time

polygon=project.poly_all
points,quantities,elevation,time=get_sts_gauge_data(project.scenario_name,polygon,verbose=False)
from Numeric import size
print 'hello', len(quantities['stage'])

assert len(points)==len(elevation)==len(quantities['stage'][0,:])

##def plot_gauge(time,quantity,quantity_name,elevation,gauge_id,pos):
##    figname=figname = '%s_%s%s.png' %('tgs/urs_gauge',
##                                      quantity_name,
##                                      str(gauge_id))
##    hold(False)
##    plot(time/60.0,quantity,label='%s (elevation = %sm)'%('urs',str(elevation)))
##    title('Gauge %d at (%f,%f)' %(gauge_id,pos[0],pos[1]))
##    xlabel('Time (minutes)')
##    ylabel(quantity_name)
##    legend()
##    print 'saving figure here %s' %figname
##    savefig(figname)
##    
##points=points[::5]
##elevation=elevation[::5]
##gauge_filename=project.boundaries_dir+sep+'urs_gauges'
##d=','
##if os.path.exists(gauge_filename+ '.txt'):
##    print 'file with list of gauges already created'
##else:
##    fid = open(gauge_filename+ '.txt', 'w')
##    fid.write('easting,northing,name,elevation\n')
##    for i in range(len(points)):
##        fid.write(str(points[i][0])+d+str(points[i][1])+d+str(i)+d+str(elevation[i])+'\n')
##    fid.close()

